var Plugin = (require('livescript-compiler/lib/livescript/Plugin')['__default__'] || require('livescript-compiler/lib/livescript/Plugin'));
var JsNode = (require('js-nodes/JsNode')['__default__'] || require('js-nodes/JsNode'));
(function(){
  var TransformTopLevelAwait, hasAwaitIn;
  module.exports = TransformTopLevelAwait = clone$(Plugin);
  Object.defineProperty(module.exports, '__default__', {enumerable:false, value: module.exports});
  TransformTopLevelAwait.name = 'transform-top-level-await';
  TransformTopLevelAwait.config = {
    overrideOptions: true
  };
  TransformTopLevelAwait.enable = function(){
    var Block, x$, originalCompileRoot, Self, checkIfAsync, wrapInAsync;
    Block = this.livescript.livescript.ast.Block;
    x$ = originalCompileRoot = Block.prototype.compileRoot;
    this.originalCompileRoot = x$;
    Self = this;
    checkIfAsync = JsNode['new'](function(options){
      this.isAsync = hasAwaitIn(this);
      if (this.isAsync && Self.config.overrideOptions) {
        options.bare = false;
      }
      if (this.isAsync && options.bare === true) {
        throw Error("Top level code should be wrap in async function but compile option 'bare' is preventing it. Hint: set override-options=true in " + Self.name);
      }
      return options;
    });
    wrapInAsync = JsNode['new'](function(result){
      var x$;
      x$ = result;
      if (this.isAsync) {
        x$.children[0] = '(async function(){\n';
      }
      return x$;
    });
    this.livescript.ast.Block.Compile.nodes.unshift(checkIfAsync);
    this.livescript.ast.Block.Compile.append(wrapInAsync);
  };
  hasAwaitIn = function(block){
    var result, isAwait;
    result = null;
    isAwait = function(child, parent, name, index){
      if (child.op === 'await') {
        result = true;
      }
      return result;
    };
    block.traverseChildren(isAwait, false);
    return result != null ? result : false;
  };
  function clone$(it){
    function fun(){} fun.prototype = it;
    return new fun;
  }
}).call(this);

//# sourceMappingURL=plugin.js.map
